%Variables that control which parts of the simulations run (they should not be changed)
onlysim=0; %0=runs everything, 1=only runs the simulation part
g_endog=0; %1=endogenous g (not coded in this version); 0= exogenous g
load_sol=1; %1=load immediately previous solution
detailed=1; %1= compute all the calibrations; 0=compute only the essential statistics
same_p=0;%1=computes equilibrium aggregate price on the first solution and then keeps that aggregate price for subsequent solutions.

%SIMULATION PARAMETERS
griglia=100; %Number of points in wealth grid
delta_step=0.005; %Parameter used later to construct nonlinear wealth grid
n_giri=800; %number of simulated periods
pspace=150; %Number of points in productivity grid
pfin=1;
pinitial=129;%the number of points (starting from pfin) that are part of the initial distribution of productivity.


%Paramenters not used in the current version (they must be kept to avoid problems in parts of the code) 
striscio=0.5; riccmult=10;cd=1;noc_inn=0;bankr_cost=0;wstep=0.25;rho=0.95;cicle=0;prodstep=0.001; F_start=0.0001;up_var=0; up_type=1;inn_type=0;inn_start=1;
gamma=2.015;beta=0;rad_last=pspace;rad_gamma=0.15;g_old=0;g_new=1;w_top=wstep*griglia;iniw_richvec=ones(100,1)*wstep*griglia*0.8;
bankr_cost_vec=zeros(100,1);probvec_vec=zeros(100,1);inn_start_vec=ones(100,1); up_delta_vec=zeros(100,1);rad_gamma_vec=0*ones(100,1);n_sectors=1;
b=1;F_const=1;up_cost=1;up2_cost=1;up_step=1;alpha=1;alpha_not=1;jump_fail=1;





%MODEL PARAMETERS (SEE TABLE 2 IN THE PAPER)
    %PART ONE: PARAMETERS FIXED TO A SINGLE VALUE
a=50010;
d=0.022; %exit probability delta
r=1.02; %gross interest rate
sigma=4;%sigma and eta are the elasticities
eta=1.5; 
colld=0.6;%This is an adjustment to wealth state variable to make sure is nevere negative
%In other words: 
%effective wealth is wt-colld
    %Bankruptcy conditon wt>=colld means wt>=0
%When computing wealth accumulation, interest is received or paid on wt-colld, so is wt+(wt-colld)r instead of (1+r)wt
di_std=0.1;%Standard deviation of distribution of initial values of productivity 
di_distance=1-0.37;%Distance between frontier technology (normalised to 1) and the average technology of new firms. 
g=1.01;% Frontier productivity growth
rad_fix=0.36;%gamma (probability to receive an innovation opportunity)
    %PART TWO: PARAMETERS SET AS A VECTOR,THEY MIGHT CHANGE ACROSS SIMULATIONS
    %note:below the index "AUX5" determines which of these values are
    %chosen for the simulation. 
F_const_vec=7.75*ones(100,1);%Sc=cost to start a firm
aggpvec=0.1188*ones(100,1);%Initial guess of the aggregate price
iniw_poorvec=[0.09 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1 1.1 1.15 1.2 1.3 1.4 1.5 1.6];
% iniw_poorvec is the vector of values of initial endowment a0
%The values set above correspond to figure 5 in the online appendix. 
%The values of the most, mid and least constrained simulated industries are 0.09, 1.15 and 1.6, respectively
volfinvec=0.35*ones(100,1); %volatility of profitability shock
rhovec=0.5*ones(100,1); %persistence of profitability shock (i.i.d. non i.i.d. case not coded)
up_cost_vec=0.1*ones(100,1);% K(1)
up2_cost_vec=0.25*ones(100,1);% K(2)
alpha_vec=0.084*ones(100,1);% xi(2)
alpha_not_vec=0.75*ones(100,1);% xi(0)
alpha2_vec=1*ones(100,1);% xi(1) 
jump_fail_vec=4*ones(100,1);%tau(2)_fail 
up_step_vec=31*ones(100,1);%tau(2)_succ
up2_step_vec=2*ones(100,1);%tau(1)_succ

aux5=1;
aux1=1;

%note: aux5<19 runs 18 different simulations, corresponding to the 18 value of a0 specified in iniw_poorvec
%to run only the 3 main simulations of  most, mid and least constrained simulated industries set iniw_poorvec=[0.09 1.15 1.6] and aux5=4

while aux5<19;
    rad_gamma=rad_gamma_vec(aux5);

nostats=0;
    
[calibration, aggstat, aggp, defstats, delimiter, evalue_store, value_store, reprof_store, stop_store, upgrade_store, wt, record_f, avg_inn, data]=g_cycle(detailed, delta_step, load_sol, F_const_vec, n_giri, noc_inn, rad_gamma, rad_last, aux5, aux1,di_distance, nostats, w_top, up_step_vec, up2_step_vec, jump_fail_vec, aggpvec,iniw_poorvec,iniw_richvec,bankr_cost_vec,probvec_vec,rhovec, volfinvec, inn_start_vec,up_cost_vec,up_delta_vec,up2_cost_vec,alpha_vec,alpha_not_vec, alpha2_vec, b, onlysim, g_endog, griglia, striscio, riccmult, a, d,r, sigma, beta,cd,colld,bankr_cost,wstep,rho,cicle,prodstep,F_const,F_start,pfin,pspace,pinitial,di_std,up_cost,up2_cost,up_var,up_type,up_step,alpha,alpha_not,inn_type,inn_start,jump_fail,eta,g,same_p,rad_fix);


if nostats==0;
    
numcol=size(defstats);
numcol=numcol(1);
aggp_save(aux5)=aggp;
aux3=1;
while aux3<n_sectors+1;    
averages=mean(aggstat(n_giri-50:n_giri,1:numcol,aux3));
if aux3<2;
if aux1<2;
    colli=size (defstats);
    
results=[defstats  (num2str(averages')) delimiter];
save('innovation1.mat','results');
end;
end;
if (aux3>1)+(aux1>1)>0;
    results=[results (num2str(averages')) delimiter ]; 
 save('innovation1.mat','results');
end;
aux3=aux3+1;
end;
results 
end;
%namef='DATALAST.csv';
%dlmwrite(namef,data,'-append');
aux5=aux5+1;
aux1=aux1+1;

end;




