function [stats calibration avg_prod aggr_inn record_f avg_inn data] = simul_bit(detailed, constr, wt, icshock, icspace, premium, rad_gamma, rad, iniw_poor, iniw_rich, F_bar, up2_cost, alpha2, jump_fail, alpha_not, F_const, inn_level, w_top, up_var, up_type, up_step, up2_step, alpha,upgrade_store, up_cost, up_delta, randf, colld,n_giri, n_parall, a,n_sectors, probvec, evalue_store,wt_ini_rich, wt_ini_poor, F_start, sigma,eta, aggp, wstep, cd, productivity, volatility, rho, reprof_store, griglia, r,d, stop_store, prod_states, vol_states,pinitial, dinitial, nostats, upgr_constrained_store, keep_store, keep_constrained_store, keep_only_store)
states=pinitial*vol_states;
calib=zeros(50,1);
pspace=size(productivity);
pspace=pspace(1);
up_cost_vec=up_cost*icshock;
up2_cost_vec=up2_cost*icshock;

%i) we calculate number of firms given initial distribution
record_f=zeros(n_giri,10); %tracks one firm
avg_inn=zeros(n_giri,1);
 
for aux2=1:pinitial
w_poor=iniw_poor;
wt_ini_rich=round(iniw_rich/wstep);


ex_ante_rich(aux2)=(max((interp1(wt,evalue_store(:,aux2),iniw_rich,'linear','extrap')-F_start),0));
ex_ante_poor(aux2)=(max((interp1(wt,evalue_store(:,aux2),iniw_poor,'linear','extrap')-F_start),0)); 


end
act_types_rich=((ex_ante_rich'.*dinitial)>0)*1;
act_types_poor=((ex_ante_poor'.*dinitial)>0)*1;





'[act_types_rich act_types_poor]'
[act_types_rich act_types_poor dinitial]

num_act_rich=act_types_rich'*act_types_rich;
num_act_poor=act_types_poor'*act_types_poor;

t_rich=act_types_rich'*dinitial;
t_poor=act_types_poor'*dinitial;

tvec=probvec*t_rich+(1-probvec)*t_poor;
frvec=tvec/sum(tvec);

frvec_rich=(probvec*t_rich)./((probvec*t_rich)+(1-probvec)*t_poor);
frvec_poor=((1-probvec)*t_poor)./((probvec*t_rich)+(1-probvec)*t_poor);

%here we calculate the frequences
d_rich=dinitial./t_rich;
d_poor=dinitial./t_poor;




aux=1;
check_r=isnan(frvec_rich);
check_p=isnan(frvec_poor);

while aux<n_sectors+1;
    if check_r(aux)==1;
       frvec_rich(aux)=0;
    end;
    if check_p(aux)==1;
       frvec_poor(aux)=0; 
    end;
aux=aux+1;
end;

sig_co=(sigma/(sigma-1))^(sigma-1);
bit_richvec=zeros(n_sectors,1);
bit_poorvec=zeros(n_sectors,1);

if num_act_rich>0;
    size(act_types_rich)
    size(d_rich)
    
    
bit_richvec=(((act_types_rich.*d_rich)'*(productivity(1:pinitial).^(sigma-1))))*frvec_rich;
end;
if num_act_poor>0;
bit_poorvec=(((act_types_poor.*d_poor)'*(productivity(1:pinitial).^(sigma-1))))*frvec_poor;
end;
    

active=(round(sig_co/((aggp)^(sigma-1)*((bit_richvec+bit_poorvec)'*frvec))));
active

activevec=active*frvec;
activevec_rich=zeros(n_sectors,1);
activevec_poor=zeros(n_sectors,1);
aux=1;
while aux<n_sectors+1;
    active=activevec(aux);
if num_act_rich>0;
    bunch_rich=round(active*frvec_rich(aux).*(act_types_rich.*d_rich));
activevec_rich(aux)=round(active*frvec_rich(aux).*(act_types_rich.*d_rich))'*act_types_rich
end;
if num_act_poor>0;
    bunch_poor=round(active*frvec_poor(aux).*(act_types_poor.*d_poor));
activevec_poor(aux)=round(active*frvec_poor(aux).*(act_types_poor.*d_poor))'*act_types_poor
end;
aux=aux+1;
end;
activevec=sum(activevec_rich+activevec_poor)
active=sum(activevec)
 
%ii) set up the variables
prod_st=zeros(active,1);%vector which keeps track of productivity index
v_st=zeros(active,1);
vol_st=zeros(active,1);
index_st=zeros(active,1);%this directly indexes to the export and stop policy functions
w_st=ones(active,1);%wealth of firm as a state variable
sector_st=ones(active,1);
shock=rand(active,1);
shock_st=(shock>0.5)*1;
icshock_st=randi(icspace,active,1);


%below we fill the cross sectional distributions

aux=1;
row=0;
while aux<n_sectors+1;
    active_rich=activevec_rich(aux);
    active_poor=activevec_poor(aux);
    active=active_rich+active_poor;
    sector_st(row+1:row+active,:)=ones(active,1)*aux;

if active_rich>0;
w_st(row+1:row+active_rich,1)=iniw_rich*ones(active_rich,1);
end;


index=row+1;

if active_rich>0;


prod_cycle=1;
while prod_cycle<pinitial+1;
    bunch=bunch_rich(prod_cycle);
    vol_cycle=1;
while vol_cycle<vol_states+1;
    

xc=(prod_cycle-1)*vol_states+vol_cycle;
if act_types_rich(xc)>0;
prod_st(index:index+bunch-1,1)=prod_cycle;
v_st(index:index+bunch-1,1)=productivity(prod_cycle);
vol_st(index:index+bunch-1,1)=vol_cycle;
index_st(index:index+bunch-1,1)=xc*2-1;

index=index+bunch;
end;
vol_cycle=vol_cycle+1;
end;
prod_cycle=prod_cycle+1;
end;
end;


'active rich'
active_rich

'index-1'
index-1



if active_poor>0;

 

prod_cycle=1;
while prod_cycle<pinitial+1; 
    
       bunch=bunch_poor(prod_cycle);

    vol_cycle=1;
while vol_cycle<vol_states+1;
xc=(prod_cycle-1)*vol_states+vol_cycle;
if act_types_poor(xc)>0;
 
    
    prod_st(index:index+bunch-1,1)=prod_cycle;
    v_st(index:index+bunch-1,1)=productivity(prod_cycle);
    vol_st(index:index+bunch-1,1)=vol_cycle;
    index_st(index:index+bunch-1,1)=xc*2-1;
    w_st(index:index+bunch-1,1)=iniw_poor;

    index=index+bunch;
end;

vol_cycle=vol_cycle+1;

end;
prod_cycle=prod_cycle+1;
end;
end;

aux=aux+1;
row=row+active;
if row>0;
if index_st(row,1)==0;
    'mmmmmmmm'
end;
end;
end;

stdec_st=zeros(active,1);
upgr_st=zeros(active,1);
keep_st=zeros(active,1);
keep_only_st=zeros(active,1);
history_mat=zeros(active,10);
history_mat2=zeros(active,2);
vars_mat=zeros(active,40,20);
max_wealth=wt(griglia);
w_st=w_st.*(w_st<max_wealth)+max_wealth.*(1-(w_st<max_wealth));

firm=1;



for (firm=1:active)
 

  
    [c aux] = min(abs(wt-w_st(firm)));
    wfirm=max(aux,1);
    stdec_st(firm)=stop_store(wfirm,icshock_st(firm), prod_st(firm));
    upgr_st(firm)=upgrade_store(wfirm,icshock_st(firm), prod_st(firm)); 
    keep_st(firm)=keep_store(wfirm,icshock_st(firm), prod_st(firm)); 
    keep_only_st(firm)=keep_only_store(wfirm,icshock_st(firm), prod_st(firm));
end

prof_labcost=ones(n_giri,1);


ncorr=0;
ncorr_mat=0;
prof_lab_mat=0;

giro=1;
stats=zeros(n_giri,6000,n_sectors);
calibration=zeros(1,6000);
shock_st=zeros(active,1);
age_st=ones(active,1);%this is the age of the firm
aggr_inn=zeros(n_giri,1);%number of total innovators



 avgp_vec=zeros(n_giri,1);

 if min(prod_st)<1;
     'problem'
     ferma now!;
 end

while giro<n_giri+1;

    
    shock=rand(active,1);
    change=shock<rho;
    shock_stnew=change;
    icshock_st=randi(icspace,active,1);
    

   

profits=zeros(active,1);
exit=zeros(active,1);
innovate=zeros(active,1);
inn_constr=zeros(active,1);
inn_prec=zeros(active,1);
keep=zeros(active,1);
pr_firm=zeros(active,1);
keep_only=zeros(active,1);
keep_constr=zeros(active,1);
keep_prec=zeros(active,1);
evalue=zeros(active,1);
cost=zeros(active,1);
firm=1;
while firm<active+1;
   row=(prod_st(firm)-1)*vol_states+vol_st(firm);
   if row<1;
       t
       firm
   prod_st(firm)
   pappa now;
   end;
   col=shock_st(firm)+1;
   colnew=shock_stnew(firm)+1;
  
   profits(firm)=reprof_store(row,colnew);
   
   [c aux] = min(abs(wt-w_st(firm)));
    wfirm=max(aux,1);
   
   
   exit(firm)=stop_store(wfirm,icshock_st(firm),prod_st(firm));
   innovate(firm)=upgrade_store(wfirm,icshock_st(firm),prod_st(firm));   
   inn_constr(firm)=upgr_constrained_store(wfirm,icshock_st(firm),prod_st(firm));

   inn_prec(firm)=innovate(firm)==0 & upgrade_store(griglia,icshock_st(firm),prod_st(firm))==1;
   pr_firm(firm)=premium(wfirm,icshock_st(firm),prod_st(firm)); 
   keep(firm)=keep_store(wfirm,icshock_st(firm),prod_st(firm)); 
   evalue(firm)=evalue_store(wfirm,prod_st(firm));
   keep_only(firm)=keep_only_store(wfirm,icshock_st(firm),prod_st(firm)); 
   keep_constr(firm)=keep_constrained_store(wfirm,icshock_st(firm),prod_st(firm));
   keep_prec(firm)=keep(firm)==0 & keep_store(griglia,icshock_st(firm),prod_st(firm))==1;
   cost(firm)=icshock(icshock_st(firm));
   firm=firm+1;
end;


if max(keep+innovate)>1;
    ferma now!;
end



%here we determine next period wealth
w_stold=w_st;

rad_prob=rad(prod_st);
rad_chance=rand(active,1)<rad_prob;
innovate_wish=innovate;
keep_wish=keep;
innovate=innovate.*rad_chance;
keep=keep.*rad_chance;


w_st=r*w_st-(r-1)*colld+profits-r*(up_cost_vec(icshock_st).*innovate+up2_cost_vec(icshock_st).*keep);%the fixed cost of exporting (effe*wstep) is paid only by the firms who start exporting this period

tot_profits=(r-1)*w_st-(r-1)*colld+profits-r*(up_cost_vec(icshock_st).*innovate+up2_cost_vec(icshock_st).*keep);


w_st=w_st.*(w_st<w_top)+w_top.*(1-(w_st<w_top));
w_st=w_st.*(w_st>wt(1))+wt(1).*(1-(w_st>wt(1)));

min_wea=colld;

if randf>0;
    'this is not programmed in this version!'
    ferma now;

end;
    


 
price=sigma/(sigma-1)*(1./productivity(prod_st));
labcost=(a./productivity(prod_st)).*((aggp^(sigma-eta))./(price.^sigma));
sales=(a*price.^(1-sigma))*(aggp^(sigma-eta));
totlab=sales-profits;
totinv=(up_cost_vec(icshock_st).*innovate+up2_cost_vec(icshock_st).*keep);


sales2=sales-volatility(vol_st).*(shock_st==1)+volatility(vol_st).*(shock_st==0);

history_mat(:,1:9)=history_mat(:,2:10);
history_mat(:,10)=tot_profits./sales;
history_mat2(:,1)=history_mat2(:,2);
history_mat2(:,2)=productivity(prod_st);


if giro==200
    ncorr=round(active*0.8);
    ncorr_mat=zeros(10,ncorr);
    prof_lab_mat=zeros(20,ncorr);
end

natural_d=(rand(active,1)<d)*1;
violent_d=(w_stold<min_wea)*1;



check=violent_d.*w_stold;

obsolete_d=exit;%firms that exit because their technology has become obsolete.


alpha_cond=(alpha-rad_gamma*((productivity(1))-productivity(prod_st)))';

        
inn_succ=(rand(active,1)<alpha_cond').*(innovate>0);
keep_succ=(rand(active,1)<alpha2).*(keep>0);
keep_only_succ=(rand(active,1)<alpha2).*(keep_only>0);
no_depr=(rand(active,1)<alpha_not).*(1-keep-innovate);

vars_mat(:,1:39,:)=vars_mat(:,2:40,:);
vars_mat(:,40,1)=sales;
vars_mat(:,40,2)=innovate.*rad_chance;
vars_mat(:,40,3)=keep.*rad_chance;
vars_mat(:,40,4)=vars_mat(:,40,2)+vars_mat(:,40,3);
vars_mat(:,40,5)=productivity(prod_st); 
vars_mat(:,40,6)=age_st; 
vars_mat(:,40,7)=(1:active)';
vars_mat(:,40,8)=giro*(ones(active,1));
vars_mat(:,40,11)=totlab;
vars_mat(:,40,12)=totinv;


death=((natural_d+violent_d+obsolete_d)>0)*1;

aggr_inn(giro)=death'*death+(inn_succ.*(1-death))'*(inn_succ.*(1-death));

aux1=natural_d'*natural_d;
aux2=violent_d'*violent_d;
aux3=obsolete_d'*obsolete_d;
aux5=mean(productivity(prod_st));

avgp_vec(giro)=aux5;

record_f(giro,1)=w_st(1);
record_f(giro,2)=profits(1);
record_f(giro,3)=innovate(1);
record_f(giro,4)=inn_succ(1);
record_f(giro,5)=prod_st(1);
record_f(giro,6)=death(1);
record_f(giro,7)=up_cost_vec(icshock_st(1));

 
constrained_keep=zeros(active,1);
constrained_innovate=zeros(active,1);
keep_cost_st=up2_cost_vec(icshock_st);
inn_cost_st=up_cost_vec(icshock_st);
for aux=1:pspace
    
    rich_keep= keep_store(griglia,1,aux);
    rich_innovate= upgrade_store(griglia,1,aux);
    constrained_keep(prod_st==aux)=((w_st(prod_st==aux)-min_wea)<keep_cost_st(prod_st==aux)).*(rich_keep==1);
    constrained_innovate(prod_st==aux)=((w_st(prod_st==aux)-min_wea)<inn_cost_st(prod_st==aux)).*(rich_innovate==1);
    
end   


vars_mat(:,40,10)=constrained_keep+constrained_innovate; 




if nostats<1;
    if giro>=n_giri-300
[calibration, stats, ncorr_mat, prof_lab_mat] = calib_inn(detailed, keep_constr, constrained_keep, constrained_innovate, tot_profits, cost, pr_firm, inn_succ, evalue, F_bar, F_const, rad_chance, keep_only, vars_mat, calibration, w_poor, w_top, up2_cost, w_st,up_cost, up_delta, sales2, alpha_not, inn_level, innovate, keep, history_mat2, n_giri, n_sectors, history_mat, ncorr, ncorr_mat, prof_lab_mat, giro, stats, active, a, labcost, sales, profits, prod_states, vol_st, wstep, cd, prod_st, volatility, w_stold, violent_d, aggp, age_st, sector_st, wt_ini_rich, vol_states, obsolete_d, productivity,inn_constr,inn_prec,death,aggr_inn, keep_prec);

    end
end
avg_inn(giro)=mean(innovate.*rad_chance);


if up_type==0
    pr_up=inn_level;
end
if up_type>0
    pr_up=prod_st-up_step;
    pr_up2=prod_st-up2_step;
    if pr_up<1
        pr_up=1;
    end
        if pr_up2<1
        pr_up2=1;
    end
    
end

prod_st_radyes=prod_st.*(1-innovate)+(prod_st+jump_fail).*innovate.*(1-inn_succ)+pr_up.*innovate.*inn_succ;
prod_st_radyes=prod_st_radyes.*(1-keep)+(prod_st_radyes+1).*keep.*(1-keep_succ)+pr_up2.*keep.*keep_succ;
prod_st_radyes=prod_st_radyes.*(keep+innovate)+prod_st_radyes.*(1-innovate-keep).*no_depr+(prod_st_radyes+1).*(1-innovate-keep).*(1-no_depr);

prod_st_radno=prod_st.*no_depr+(prod_st+1).*(1-no_depr);
    
prod_st=prod_st_radyes.*rad_chance+prod_st_radno.*(1-rad_chance);

prod_st=prod_st.*(prod_st>0)+1.*(prod_st<1);

if max(prod_st)>pspace

prod_st=prod_st.*(prod_st<=pspace)+pspace.*(prod_st>pspace);   
end



vars_mat(:,40,9)=productivity(prod_st); 
if giro==n_giri
prod_data=reshape(vars_mat(:,31:40,5),[],1); 
prodf_data=reshape(vars_mat(:,31:40,9),[],1); 
age_data=reshape(vars_mat(:,31:40,6),[],1);
constrained_data=reshape(vars_mat(:,31:40,10),[],1);
sales_data=reshape(vars_mat(:,31:40,1),[],1);
lab_data=reshape(vars_mat(:,31:40,11),[],1);
inv_data=reshape(vars_mat(:,31:40,12),[],1);
nobs=activenew+addfirms;
if nobs>20000
    'firm indexing incorrect'  
end
fake_firm=(1:nobs)'*ones(1,10);
constr_data=constr*ones(nobs,10);
size(vars_mat(:,31:40,6))
size(fake_firm)
firm_data=reshape(fake_firm,[],1);
constr_data=reshape(constr_data,[],1);
year_data=reshape(vars_mat(:,31:40,8),[],1);



data=[prod_data prodf_data age_data firm_data year_data constr_data constrained_data sales_data lab_data inv_data];
end


shock_st=shock_stnew;

%now we need to recompact the vectors of the states
activenew=active-death'*death;
firm=1;
newfirm=1;
w_stnew=zeros(activenew,1);
prod_stnew=zeros(activenew,1);
vol_stnew=zeros(activenew,1);
shock_stnew=zeros(activenew,1);
vnew=zeros(activenew,1);
age_stnew=zeros(activenew,1);
sector_stnew=zeros(activenew,1);
history_matnew=zeros(activenew,10);
history_mat2new=zeros(activenew,2);
vars_matnew=zeros(activenew,40,20);

while firm<active+1;
    if death(firm)<1;   
        
    index=((prod_st(firm)-1)*vol_states+vol_st(firm))*2-1;
    vec=index+shock_st(firm);
    w_stnew(newfirm)=w_st(firm);
    prod_stnew(newfirm)=prod_st(firm);
    vnew(newfirm)=productivity(prod_stnew(newfirm));
    vol_stnew(newfirm)=vol_st(firm);
    shock_stnew(newfirm)=shock_st(firm);
    age_stnew(newfirm)=age_st(firm)+1;%surviving firms are one ywar older!
    sector_stnew(newfirm)=sector_st(firm);
    history_matnew(newfirm,:)=history_mat(firm,:);
    history_mat2new(newfirm,:)=history_mat2(firm,:);
    
    
    vars_matnew(newfirm,:,:)=vars_mat(firm,:,:);
    newfirm=newfirm+1;
    end;
    firm=firm+1;
end;


sig_co=(sigma/(sigma-1))^(1-sigma);
oldg=(ones(activenew,1)'*(vnew.^(sigma-1)))*sig_co;
pguess=aggp+1;
mguess=1000000;
if giro>20;
    mguess=oldguess;
end;
delta=0.5;
change=0;
while abs(pguess-aggp)>0.0001;   
    prevchange=change;
    newg=mguess*sig_co*((bit_richvec+bit_poorvec)'*frvec);
    pguess=(newg+oldg)^(1/(1-sigma));

if pguess-aggp<0;
    change=-1;
    if prevchange>0;
    delta=delta/2;    
    end;
    mguess=mguess*(1-delta);
end;

if pguess-aggp>0;
    change=1;
    if prevchange<0;
    delta=delta/2;    
    end;
    mguess=mguess*(1+delta);
end;

if mguess<10;
    if giro>100;
    'less than 10 new entrants! (corrected)'
    giro
    end;
    mguess=10;
    pguess=aggp;
end;
    

end;

oldguess=mguess;

newbornvec=mguess*frvec;
newbornvec_rich=zeros(n_sectors,1);
newbornvec_poor=zeros(n_sectors,1);
aux=1;
while aux<n_sectors+1;
    active=newbornvec(aux);


    
if num_act_rich>0;
bunch_rich=round(active*frvec_rich(aux).*(act_types_rich.*d_rich));    
newbornvec_rich(aux)=round(active*frvec_rich(aux).*(act_types_rich.*d_rich))'*act_types_rich;
end;
if num_act_poor>0;
    bunch_poor=round(active*frvec_poor(aux).*(act_types_poor.*d_poor));
newbornvec_poor(aux)=round(active*frvec_poor(aux).*(act_types_poor.*d_poor))'*act_types_poor;
end;
aux=aux+1;
end;
newbornvec=sum(newbornvec_rich+newbornvec_poor);
addfirms=sum(newbornvec);



w_add=ones(addfirms,1);
prod_add=zeros(addfirms,1);
vol_add=zeros(addfirms,1);
shock_add=zeros(addfirms,1);
index_add=zeros(addfirms,1);
age_stadd=ones(addfirms,1);
v_add=zeros(addfirms,1);
sector_add=zeros(addfirms,1);
history_matadd=zeros(addfirms,10);
history_mat2add=zeros(addfirms,2);
vars_matadd=zeros(addfirms,40,20);


aux=1;
row=0;
while aux<n_sectors+1;
    active_rich=newbornvec_rich(aux);
    active_poor=newbornvec_poor(aux);
    active=active_rich+active_poor;
    sector_add(row+1:row+active,:)=ones(active,1)*aux;

    

    
    
if active_rich>0;
w_add(row+1:row+active_rich,1)=iniw_rich*ones(active_rich,1);
end;



index=row+1;

if active_rich>0;


prod_cycle=1;
while prod_cycle<pinitial+1;  
    bunch=bunch_rich(prod_cycle);
    vol_cycle=1;
while vol_cycle<vol_states+1;
    

xc=(prod_cycle-1)*vol_states+vol_cycle;
if act_types_rich(xc)>0;
prod_add(index:index+bunch-1,1)=prod_cycle;
v_add(index:index+bunch-1,1)=productivity(prod_cycle);
vol_add(index:index+bunch-1,1)=vol_cycle;
index_add(index:index+bunch-1,1)=xc*2-1;

index=index+bunch;
end;
vol_cycle=vol_cycle+1;
end;
prod_cycle=prod_cycle+1;
end;
end;


if active_poor>0;

 

prod_cycle=1;
while prod_cycle<pinitial+1;  
        bunch=bunch_poor(prod_cycle);
    vol_cycle=1;
while vol_cycle<vol_states+1;
xc=(prod_cycle-1)*vol_states+vol_cycle;
if act_types_poor(xc)>0;
 
    
    prod_add(index:index+bunch-1,1)=prod_cycle;
    v_add(index:index+bunch-1,1)=productivity(prod_cycle);
    vol_add(index:index+bunch-1,1)=vol_cycle;
     w_add(index:index+bunch-1,1)=iniw_poor;
    
    index_add(index:index+bunch-1,1)=xc*2-1;
    index=index+bunch;
end;

vol_cycle=vol_cycle+1;

end;
prod_cycle=prod_cycle+1;
end;
end;



aux=aux+1;
row=row+active;

end;



shock=rand(addfirms,1);
shock_add=(shock>0.5)*1;
firm=1;
active=activenew+addfirms;

w_st=[w_stnew; w_add];
prod_st=[prod_stnew; prod_add];
vol_st=[vol_stnew; vol_add];
shock_st=[shock_stnew; shock_add];
age_st=[age_stnew; age_stadd];
sector_st=[sector_stnew; sector_add];
history_mat=[history_matnew; history_matadd];
history_mat2=[history_mat2new; history_mat2add];
vars_mat=zeros(activenew+addfirms,40,10);



for aux=1:20
    vars_mat(:,:,aux)=[vars_matnew(:,:,aux); vars_matadd(:,:,aux)];
end
giro=giro+1;

if abs(round(giro/100)-(giro/100))<0.0000000001;
    giro
end;


%check wealth of new firms
check=(age_st==1).*w_st;
check=check(check>0);
check2=(age_st==1).*F_bar(prod_st);
check=check(check>0);
check2=check2(check2>0);
aux=size(prod_st);
if aux(1)~=active;
    size(prod_stnew)
    size(prod_add)
    size(w_stnew)
    size(w_add)
    
    active
    addfirms
    ferma now;
end
w_st=w_st.*(w_st<max_wealth)+max_wealth.*(1-(w_st<max_wealth));
end;
avg_prod=mean(avgp_vec(100:n_giri));
avg_prod;

'natural deaths, violent deaths, obsolescence death'
[aux1 aux2 aux3]






 